' Etna library, by Progi1984 and RepeatUntil
' License:
' This library is an "email-ware". This means that this library is free. However, if you use this library
' in one of your project, you MUST contact the authors saying that you are using Etna. An email is required
' whatever is the status of the project: commercial or non-commercial, completed or in development. Even if
' the project is just starting, is just private or will never be released, you are still required to send an
' email. Needless to say, your email won't be use except for the authors to do a count of their users.
' If you wish, you could describe your project in your email, and we can even include a link to your project
' on this web page if you authorize us.
' To contact the authors: progi1984@free.fr, repeatuntil@free.fr or the Etna forum.



' Definition of the functions in the dll
Global ETNA__SetServer(server:Byte Ptr)"Win32"
Global ETNA__SetDelimiter(delimiter:Byte Ptr)"Win32"
Global ETNA__SetKey(key:Byte Ptr)"Win32"
Global ETNA__SetKeySend(key:Byte Ptr)"Win32"
Global ETNA__SetKeyReceive(key:Byte Ptr)"Win32"
Global ETNA_Update()"Win32"
Global ETNA__Send(ID%, command:Byte Ptr, encrypted%, highPriority%)"Win32"
Global ETNA_GetNumberOfCommandsInQueue%()"Win32"
Global ETNA_Cancel(ID%)"Win32"
Global ETNA_Receive%(ID%)"Win32"
Global ETNA_GetState%()"Win32"
Global ETNA__GetResult:Byte Ptr(line%)"Win32"
Global ETNA_GetNbOfLines%()"Win32"

' Constants for the state (ETNA_GetState)
Const ETNA_OK% = 2
Const ETNA_NO_NETWORK% = 3
Const ETNA_CONNECTION_FAILED% = 4
Const ETNA_REQUEST_ERROR% = 5
Const ETNA_SYSTEM_ERROR% = 6
' To run without thread for a special command
Const ETNA_NO_THREAD% = -999


' Initialise the lib. Return false if not able to initialise
Function ETNA_Initialise%()
	Local ETNA_DllHandle% = LoadLibraryA("ETNA.dll")

	If ETNA_DLLhandle = 0 Then
 	  Return False
	EndIf

	ETNA__SetServer = GetProcAddress(ETNA_DllHandle,"ETNA__SetServer")
	ETNA__SetDelimiter = GetProcAddress(ETNA_DllHandle,"ETNA__SetDelimiter")
	ETNA__SetKey = GetProcAddress(ETNA_DllHandle,"ETNA__SetKey")
	ETNA__SetKeySend = GetProcAddress(ETNA_DllHandle,"ETNA_)SetKeySend")
	ETNA__SetKeyReceive = GetProcAddress(ETNA_DllHandle,"ETNA__SetKeyReceive")
	ETNA_Update = GetProcAddress(ETNA_DllHandle,"ETNA_Update")
	ETNA__Send = GetProcAddress(ETNA_DllHandle,"ETNA__Send")
	ETNA_GetNumberOfCommandsInQueue = GetProcAddress(ETNA_DllHandle,"ETNA_GetNumberOfCommandsInQueue")
	ETNA_Cancel = GetProcAddress(ETNA_DllHandle,"ETNA_Cancel")
	ETNA_Receive = GetProcAddress(ETNA_DllHandle,"ETNA_Receive")
	ETNA_GetState = GetProcAddress(ETNA_DllHandle,"ETNA_GetState")
	ETNA__GetResult = GetProcAddress(ETNA_DllHandle,"ETNA__GetResult")
	ETNA_GetNbOfLines = GetProcAddress(ETNA_DllHandle,"ETNA_GetNbOfLines")

	Return True
End Function

' Redefine some functions to get default arguments or to use Byte Ptr easily for the user
Function ETNA_SetServer(server$)
	Local serverCStr:Byte Ptr = server.toCString()
	ETNA__SetServer(serverCStr)
	MemFree serverCStr
End Function

Function ETNA_SetDelimiter(delimiter$)
	Local delimiterCStr:Byte Ptr = delimiter.toCString()
	ETNA__SetDelimiter(delimiterCStr)
	MemFree delimiterCStr
End Function

Function ETNA_SetKey(key$)
	Local keyCStr:Byte Ptr = key.toCString()
	ETNA__SetKey(keyCStr)
	MemFree keyCStr
End Function

Function ETNA_SetKeySend(key$)
	Local keyCStr:Byte Ptr = key.toCString()
	ETNA__SetKeySend(keyCStr)
	MemFree keyCStr
End Function

Function ETNA_SetKeyReceive(key$)
	Local keyCStr:Byte Ptr = key.toCString()
	ETNA__SetKeyReceive(keyCStr)
	MemFree keyCStr
End Function


Function ETNA_GetResult$(line% = -1)
	Return String.FromCString(ETNA__GetResult(line))
End Function

Function ETNA_Send(ID%, command$, encrypted% = False, highPriority% = False)
	Local commandCStr:Byte Ptr = command.toCString()
	ETNA__Send(ID%, commandCStr, encrypted, highPriority%)
	MemFree commandCStr
End Function
