/*
Etna library, by Progi1984 and RepeatUntil (C++ wrapper by FRA)
License:
This library is an "email-ware". This means that this library is free. However, if you use this library
in one of your project, you MUST contact the authors saying that you are using Etna. An email is required
whatever is the status of the project: commercial or non-commercial, completed or in development. Even if
the project is just starting, is just private or will never be released, you are still required to send an
email. Needless to say, your email won't be use except for the authors to do a count of their users.
If you wish, you could describe your project in your email, and we can even include a link to your project
on this web page if you authorize us.
To contact the authors: progi1984@free.fr, repeatuntil@free.fr or the Etna forum : 
http://blitzklan.free.fr/forum/viewforum.php?f=32.
	#### /!\ IMPORTANT ! #### The C++ ETNA functions names don't have the prefix "ETNA_" so don't forget to remove them when using the lib ;-)
*/
#ifndef ETNA_H
#define ETNA_H

#include <tchar.h>
#include <windows.h>
#include <string.h>
#include <stdio.h>

// Constant To run without thread for a special command 
#define ETNA_NO_THREAD   -999
// Constants for the state (ETNA_GetState)
#define ETNA_OK   2
#define ETNA_NO_NETWORK   3
#define ETNA_CONNECTION_FAILED   4
#define ETNA_REQUEST_ERROR   5
#define ETNA_SYSTEM_ERROR   6

class InterfaceETNA
{
public:
	// fonctions ETNA non importes de la dll
	//! Constructeur de l'objet InterfaceETNA
	InterfaceETNA(void){
		hDLL = NULL;               // Handle to DLL

		SetDelimiterInterne = NULL;

		CancelInterne = NULL;

		GetNumberOfCommandsInQueueInterne = NULL;

		UpdateInterne = NULL;

		ReceiveInterne = NULL;

		GetStateInterne = NULL;

		GetNbOfLinesInterne = NULL;

		GetResultInterne = NULL;
 
		SetKeyInterne = NULL;

		SetKeyReceiveInterne = NULL;

		SetKeySendInterne = NULL;

		SetServerInterne = NULL;

		SendInterne = NULL;
	}

	//! Destructeur de l'objet
	~InterfaceETNA(void)
	{
		Free();
	}
	//! Initialise l'interface; charge les fonctions de la dll
	//! la valeur de retour informe si le chargement a russi ou chou
	bool Initialise(){

	hDLL = LoadLibrary(_T("Etna.dll"));

	if (hDLL == NULL)
		return false;
	FARPROC lpfnGetSetDelimiterProcessID;
	FARPROC lpfnGetCancelProcessID;
	FARPROC lpfnGetGetNumberOfCommandsInQueueProcessID;
	FARPROC lpfnGetReceiveProcessID;
	FARPROC lpfnGetGetStateProcessID;
	FARPROC lpfnGetGetNbOfLinesProcessID;
	FARPROC lpfnGetGetResultProcessID;
	FARPROC lpfnGetSetKeyProcessID;
	FARPROC lpfnGetSetKeyReceiveProcessID;
	FARPROC lpfnGetSendProcessID;
	FARPROC lpfnGetSetServerProcessID;
	FARPROC lpfnGetSetKeySendProcessID;
	FARPROC lpfnGetUpdateProcessID;

	lpfnGetSetServerProcessID = GetProcAddress(HMODULE(hDLL), 
		"ETNA_SetServer");
	lpfnGetSendProcessID = GetProcAddress(HMODULE(hDLL), 
		"ETNA__Send");
	lpfnGetSetDelimiterProcessID = GetProcAddress(HMODULE(hDLL), 
		"ETNA_SetDelimiter");
	lpfnGetCancelProcessID = GetProcAddress(HMODULE(hDLL), 
		"ETNA_Cancel");
	lpfnGetGetNumberOfCommandsInQueueProcessID = GetProcAddress(HMODULE(hDLL), 
		"ETNA_GetNumberOfCommandsInQueue");
	lpfnGetUpdateProcessID = GetProcAddress(HMODULE(hDLL), 
		"ETNA_Update");
	lpfnGetReceiveProcessID = GetProcAddress(HMODULE(hDLL),
		"ETNA_Receive");
	lpfnGetGetStateProcessID = GetProcAddress(HMODULE(hDLL), 
		"ETNA_GetState");
	lpfnGetGetNbOfLinesProcessID = GetProcAddress(HMODULE(hDLL), 
		"ETNA_GetNbOfLines");
	lpfnGetGetResultProcessID = GetProcAddress(HMODULE(hDLL), 
		"ETNA__GetResult");
	lpfnGetSetKeyProcessID = GetProcAddress(HMODULE(hDLL), 
		"ETNA_SetKey");
	lpfnGetSetKeyReceiveProcessID = GetProcAddress(HMODULE(hDLL), 
		"ETNA_SetKeyReceive");
	lpfnGetSetKeySendProcessID = GetProcAddress(HMODULE(hDLL), 
		"ETNA_SetKeySend");

	if ((lpfnGetSetServerProcessID == NULL)|| (lpfnGetSetKeySendProcessID == NULL )||
		(lpfnGetSendProcessID == NULL)|| (lpfnGetSetDelimiterProcessID == NULL)|| 
		(lpfnGetCancelProcessID == NULL)|| (lpfnGetGetNumberOfCommandsInQueueProcessID == NULL)|| 
		(lpfnGetUpdateProcessID == NULL)|| (lpfnGetReceiveProcessID == NULL)|| 
		(lpfnGetGetStateProcessID == NULL)|| (lpfnGetGetNbOfLinesProcessID == NULL)|| 
		(lpfnGetGetResultProcessID == NULL)|| (lpfnGetSetKeyProcessID == NULL)|| 
		(lpfnGetSetKeyReceiveProcessID == NULL))
		return false;

	SetServerInterne = pSetServerFUNC(lpfnGetSetServerProcessID);
	SendInterne = pSendFUNC(lpfnGetSendProcessID);
	SetDelimiterInterne = pSetDelimiterFUNC(lpfnGetSetDelimiterProcessID);
	CancelInterne = pCancelFUNC(lpfnGetCancelProcessID);
	GetNumberOfCommandsInQueueInterne = pGetNumberOfCommandsInQueueFUNC(lpfnGetGetNumberOfCommandsInQueueProcessID);
	UpdateInterne = pUpdateFUNC(lpfnGetUpdateProcessID);
	ReceiveInterne = pReceiveFUNC(lpfnGetReceiveProcessID);
	GetStateInterne = pGetStateFUNC(lpfnGetGetStateProcessID);
	GetNbOfLinesInterne = pGetNbOfLinesFUNC(lpfnGetGetNbOfLinesProcessID);
	GetResultInterne = pGetResultFUNC(lpfnGetGetResultProcessID);
	SetKeyInterne = pSetKeyFUNC(lpfnGetSetKeyProcessID);
	SetKeyReceiveInterne = pSetKeyReceiveFUNC(lpfnGetSetKeyReceiveProcessID);
	SetKeySendInterne = pSetKeySendFUNC(lpfnGetSetKeySendProcessID);

	if ((SetServerInterne == NULL)||(SetKeySendInterne == NULL )||
		(SendInterne == NULL)|| (SetDelimiterInterne == NULL)|| 
		(CancelInterne == NULL)|| (GetNumberOfCommandsInQueueInterne == NULL)|| 
		(UpdateInterne == NULL)|| (ReceiveInterne == NULL)|| 
		(GetStateInterne == NULL)|| (GetNbOfLinesInterne == NULL)|| 
		(GetResultInterne == NULL)|| (SetKeyInterne == NULL)|| 
		(SetKeyReceiveInterne == NULL))
		return false;

	return true;
}


	//! Libre la librairie ( ne doit pas tre appel )
private:
	void Free(){
	FreeLibrary(HMODULE(hDLL));
}
public: 
	 
	//! Function returning the result of the last request received. ETNA_GetState() should have returned ETNA_OK to get a non empty result.
	//! Use this right after ETNA_Receive() for a threaded request and right after ETNA_Send() for a non-threaded request.
	//! ETNA will detect automatically if the string result is encrypted, and will decrypt it in that case. See the tutorial for more details on encryption.
	char *GetResult(int NbLine = -1){
		return this->GetResultInterne(NbLine);
	}
	//! Send a request to the server. You can send a threaded or non-threaded request depending on the ID argument. For a threaded request, this function returns immediately and the program can continue.
	//! You can also encrypt the information you send. This is very easy, you just have to set the parameter encrypted to True. Of course, your script should decrypt the information, but ETNA is providing the function to do that: refer to the tutorial or the library section for more details.
	//! Note that all requests are garanteed to arrive in the same order they were sent.
	void Send(int ID, char *Command, bool Encrypted = false, bool HighPriority = false)
	{
		int EncryptedInt, HighPriorityInt;
		if (Encrypted == false)
			EncryptedInt = 0;
		else
			EncryptedInt = 1;

		if (HighPriority == false)
			HighPriorityInt = 0;
		else
			HighPriorityInt = 1;

		this->SendInterne(ID, Command, EncryptedInt, HighPriorityInt);
	}

	//! Specify the delimiter when the result of the request contains more than one line. By default, this is a carriage return - chr(13).
	//! The delimiter may be more than one character long.
	void SetDelimiter(char *Delimiter)
	{
		this->SetDelimiterInterne(Delimiter);
	}

	//! Function to cancel a certain type of ID in the queue (for threaded requests). It is not possible to cancel a command already running!
	void Cancel(int ID)
	{
		this->CancelInterne(ID);
	}

	//! Function returning the number of commands in the queue (for threaded requests). Make sure that the queue is not growing exponentially!
	int GetNumberOfCommandsInQueue()
	{
		return this->GetNumberOfCommandsInQueueInterne();
	}

	//! Handle the threaded requests. Put this function in your main loop if you use requests with thread (see ETNA_Send()).
	//! This function is not needed for a non-threaded request.
	//! WARNING: this is the central function for the threaded requests: do not forget to call this function regularly (ideally in the main loop)!!
	void Update()
	{
		this->UpdateInterne();
	}

	//! Function to check if the result of a command was received. If the result is True, use the functions ETNA_GetState() and ETNA_GetResult() to get the results.
	//! This function is for the threaded requests only. A call to ETNA_Update() needs to be done before a call to this function (ideally in the main loop).
	//! Note that all requests are garanteed to arrive in the same order they were sent.
	bool Receive(int Line)
	{
		int ReturnedValue = this->ReceiveInterne(Line);
		if (ReturnedValue == 0)
			return false;
		else
			return true;
	}

	//! Function returning the state (OK or error) of the last request received. Use this right after ETNA_Receive() for a threaded request and right after ETNA_Send() for a non-threaded request. If there is no error, use ETNA_GetResult() to get the result.
	int GetState()
	{
		return GetStateInterne();
	}

	//! Function returning the number of lines in the output of the script on the server.
	int GetNbOfLines()
	{
		return this->GetNbOfLinesInterne();
	}

	//! When you use encryption, use this function to set the encryption key. This sets the key to and from the server (see the two next functions if you want different keys).
	//! This key should be the same on the program side and the script side. You may call this function several times to set different keys for different scripts.
	//! Advice for improved security: do not use simple keys, or keys belonging to the dictionnary. "sG4%fh*$^k" is better than "secret"!
	void SetKey(char * Key)
	{
		this->SetKeyInterne(Key);
	}

	//! When you use encryption, use this function to set the encryption key when you receive the information from the server (with ETNA_GetResult()). The information coming from the server (from the script) will be decrypted with this key.
	//! This key should be the same on the program side and the script side. You may call this function several times to set different keys for different scripts.
	void SetKeyReceive(char *Key)
	{
		this->SetKeyReceiveInterne(Key);
	}
	//! When you use encryption, use this function to set the encryption key when you send information to the server(with ETNA_Send()). The information going to the server (to the script) will be encrypted with this key.
	//! This key should be the same on the program side and the script side. You may call this function several times to set different keys for different scripts.
	void SetKeySend(char *Key)
	{
		this->SetKeySendInterne(Key);
	}
	//!Specify to Etna the server address where are located the script files (like php files). You can also specify a directory on the server.
	//!This function should be called at least once, but could be called at any moment to use different servers.
	void SetServer(char *Server)
	{
		this->SetServerInterne(Server);
	}


	// variables stockant tout les handles necessaires
	typedef void (__stdcall *pSetDelimiterFUNC)(char*);
	typedef void (__stdcall *pCancelFUNC)(int);
	typedef int (__stdcall *pGetNumberOfCommandsInQueueFUNC)();
	typedef void (__stdcall *pUpdateFUNC)();
	typedef bool (__stdcall *pReceiveFUNC)(int);
	typedef int (__stdcall *pGetStateFUNC)();
	typedef int (__stdcall *pGetNbOfLinesFUNC)();
	typedef char * (__stdcall *pGetResultFUNC)(int);
	typedef void (__stdcall *pSetKeyFUNC)(char*);
	typedef void (__stdcall *pSetKeyReceiveFUNC)(char*);
	typedef void (__stdcall *pSetKeySendFUNC)(char*);
	typedef void (__stdcall * pSetServerFUNC)(char*);
	typedef void (__stdcall * pSendFUNC)(int, char*, int, int);

private:
	//! Handle to DLL, ne doit pas tre utilis
	HINSTANCE hDLL;
	//! pointeur de fonction interne, ne doit pas tre utilis
	pSendFUNC SendInterne;
	//! pointeur de fonction interne, ne doit pas tre utilis
	pGetResultFUNC GetResultInterne;
	//! pointeur de fonction interne, ne doit pas tre utilis
	pSetDelimiterFUNC SetDelimiterInterne;
	//! pointeur de fonction interne, ne doit pas tre utilis
	pCancelFUNC CancelInterne;
	//! pointeur de fonction interne, ne doit pas tre utilis
	pGetNumberOfCommandsInQueueFUNC GetNumberOfCommandsInQueueInterne;
	//! pointeur de fonction interne, ne doit pas tre utilis
	pUpdateFUNC UpdateInterne;
	//! pointeur de fonction interne, ne doit pas tre utilis
	pReceiveFUNC ReceiveInterne;
	//! pointeur de fonction interne, ne doit pas tre utilis
	pGetStateFUNC GetStateInterne;
	//! pointeur de fonction interne, ne doit pas tre utilis
	pGetNbOfLinesFUNC GetNbOfLinesInterne;
	//! pointeur de fonction interne, ne doit pas tre utilis
	pSetKeyFUNC SetKeyInterne;
	//! pointeur de fonction interne, ne doit pas tre utilis
	pSetKeyReceiveFUNC SetKeyReceiveInterne;
	//! pointeur de fonction interne, ne doit pas tre utilis
	pSetKeySendFUNC SetKeySendInterne;
	//! pointeur de fonction interne, ne doit pas tre utilis
	pSetServerFUNC SetServerInterne;
};
#endif