unit ETNA_inc;

interface

type
  TArrayOfChar = Array[0..10000] of Char;

Const
  // Constants
  ETNA_NO_THREAD = -999;
  ETNA_OK = 2;
  ETNA_NO_NETWORK = 3;
  ETNA_CONNECTION_FAILED = 4;
  ETNA_REQUEST_ERROR = 5;
  ETNA_SYSTEM_ERROR = 6;

  NomDLL = 'ETNA.dll';
  Procedure ETNA_SetServer(server: string); stdcall; external NomDLL;
  Procedure ETNA_SetDelimiter(delimiter: string); stdcall; external NomDLL;
  Procedure ETNA_Send(ID: integer; command: string; encrypted: boolean = False; highPriority: boolean = False); stdcall; external NomDLL name 'ETNA__Send';
  Procedure ETNA_Cancel(ID: integer); stdcall; external NomDLL;
  Function ETNA_GetNumberOfCommandsInQueue(): integer; stdcall; external NomDLL;
  Procedure ETNA_Update(); stdcall; external NomDLL;
  Function ETNA_Receive(ID: integer): Boolean; stdcall; external NomDLL;
  Function ETNA_GetState(): Integer; stdcall; external NomDLL;
  Function ETNA_GetNbOfLines(): integer; stdcall; external NomDLL;
  Function ETNA__GetResult(lineNb: integer): Pointer; stdcall; external NomDLL;
  Function ETNA_GetResult(lineNb: integer = -1): TArrayOfChar;
  Procedure ETNA_SetKey(key: string); stdcall; external NomDLL;
  Procedure ETNA_SetKeyReceive(key: string); stdcall; external NomDLL;
  Procedure ETNA_SetKeySend(key: string); stdcall; external NomDLL;

implementation
{ ETNA }

Function ETNA_GetResult(lineNb: integer = -1): TArrayOfChar;
var
  text: ^TArrayOfChar;
begin
        text := ETNA__GetResult(lineNb);
        result := text^;
end;

end.



