;Constants config :::::::::::::::::::::::::::::::::::::::::::::::::::
Global screen_width% = 800
Global screen_height% = 600
Global screen_depth% = 0
Global screen_mode% = 2
Global screen_halfwidth% = screen_width/2
Global screen_halfheight% = screen_height/2

Const SET_VALUE% = 1
Const GET_VALUE% = 2

;Screen
Graphics3D screen_width,screen_height,screen_depth,screen_mode
SetBuffer BackBuffer()

Sys_Loading(0)

AppTitle "ETNA Chat Demo - by LoKi"

HidePointer
SeedRnd MilliSecs()

;ETNA Init :::::::::::::::::::::::::::::::::::::::::::::::::::::::

;Including ETNA
Include "../../BlitzBasic/Etna_inc.bb" 


;Init
ETNA_SetServer("http://repeatuntil.online.fr/Etna")

;Framerate :::::::::::::::::::::::::::::::::::::::::::::::::::::::
gameFPS = 60.0
framePeriod = 1000 / gameFPS
frameTime = MilliSecs () - framePeriod

Sys_Loading(10)

;Skybox
sky = Map_CreateSkybox()

;Sphere
sphere = CreateSphere(16)
tex = LoadTexture("res/ban.jpg")
ScaleTexture tex, 0.8, 0.8
EntityTexture sphere, tex
MoveEntity sphere, 2, 0, 3

Sys_Loading(60)

;Banner
ban = LoadImage("res/ban.jpg")
MaskImage ban,255,0,255

Sys_Loading(90)

;Player
Locate screen_halfwidth-100,screen_halfheight-10

Color 0,0,0
pseudo$=Input("Your name ? ")

If pseudo$="" Then
	pseudo$="Anonyme"+Rand(0,100)
EndIf

;Camera
Global camera = CreateCamera()
CameraViewport camera,0,100,screen_width,screen_height-100
CameraClsMode camera,1,1
CameraFogColor camera,255,255,255
CameraFogMode camera,1
CameraClsColor camera,255,255,255
CameraRange camera,1,100000
CameraZoom camera,1
MoveEntity camera,0,.5,-2

; Shootbox
Global chat$

Global messageInfo$

Sys_Loading(100)

; Drawing the Banner
DrawImage ban,0,0

chrono_update% = 0

While Not KeyHit(1)
	ETNA_Update()
	
	;Interception of result of the request
	If ETNA_Receive(GET_VALUE) Then
		If ETNA_GetState() = ETNA_OK Then
			;Reception of the chat

			messageInfo = ""
					
			;Delete all posts
			Scr_FlushPosts()
			
			Local rec_author$ = ""
			Local rec_date$ = ""
			Local rec_msg$ = ""
		
			;Parsing of the answer and creation of all new messages
			For i% = ETNA_GetNbOfLines() To 1 Step -3
				; Going in the backward direction to put the last message at the end
				rec_author$=ETNA_GetResult(i - 2)							
				rec_date$=ETNA_GetResult(i - 1)
				rec_msg$=ETNA_GetResult(i)	
				Scr_NewPost(rec_author$, rec_date$, rec_msg$)	
			Next
		Else
			messageInfo = "Unable to update the Chat! Error = " + ETNA_GetState()				
		EndIf
	EndIf
	
	If ETNA_Receive(SET_VALUE) Then
		; Answer of the server after the sending
		If ETNA_GetState() <> ETNA_OK Then messageInfo$ = "Unable to send the chat text! Error = " + ETNA_GetState() Else messageInfo$ = ""
	EndIf


	;F10 for a screenshot
	If KeyHit(68)=1 Then 
		ok = False
		While (Not ok)
			If FileType(CurrentDir$ + "Screenshot" + ext + ".bmp") = 0 Then
				SaveBuffer FrontBuffer(), "Screenshot" + ext + ".bmp"
				ok = True
			End If
			ext = ext + 1
		Wend
	End If	
	
	; Obtaining new messages
	chrono_update% = chrono_update% - 1
	If chrono_update% <= 0 Then
		messageInfo$ = "Updating the chat..."
		ETNA_Send(GET_VALUE,"ETNA_Chat.php?option=getchat")
		chrono_update% = 500
	EndIf
	
	; Management of input
	key = GetKey()

	If key=8 Then
		;Delete
		If Len(chat$)>0 Then chat$=Left$(chat$,Len(chat$)-1)
	ElseIf key>=32 And key<127 Then
		;Alphabet
		chat$=chat$+Chr$(key)
	EndIf
	
	;Delete
	If DelCount > 500 Then
		If KeyDown(14) Then
			If Len(chat$)>0 Then chat$=Left$(chat$,Len(chat$)-1)
		Else
			DelCount = 0
		End If
	Else
		If KeyDown(14) Then
			DelCount = DelCount + InputFreq Else DelCount = 0
		EndIf
	End If

	; Sending a message
	If KeyHit(28)=1 And chat$<>"" Then
		ETNA_Send(SET_VALUE,"ETNA_Chat.php?option=setchat&msg=" + chat$ + "&author=" + pseudo$)
		chat$ = ""
		chrono_update% = 0
	EndIf
	
	; Flush key states and character queue
	FlushKeys()

	; Move the sky
	TurnEntity sky,0,.1,0
	TurnEntity sphere, 0, 2, 0
	
	;Render
	RenderWorld()
	
	; Drawing the chat in a console
	Scr_Consoledisplay()
	
	; Drawing the shootbox
	Chat_display()
	
	Flip
Wend

End




;::::::::::::::::::::::::::
;         Skybox
;::::::::::::::::::::::::::
Function Map_CreateSkybox()
	mesh = CreateMesh()

	;front face
	brush = LoadBrush("res/sky/front.jpg",49)
	surface = CreateSurface(mesh,brush)
	AddVertex surface,-1,+1,-1,0,0
	AddVertex surface,+1,+1,-1,1,0
	AddVertex surface,+1,-1,-1,1,1
	AddVertex surface,-1,-1,-1,0,1
	AddTriangle surface,0,1,2
	AddTriangle surface,0,2,3
	FreeBrush brush

	;right face
	brush = LoadBrush("res/sky/left.jpg",49)
	surface = CreateSurface(mesh,brush)
	AddVertex surface,+1,+1,-1,0,0
	AddVertex surface,+1,+1,+1,1,0
	AddVertex surface,+1,-1,+1,1,1
	AddVertex surface,+1,-1,-1,0,1
	AddTriangle surface,0,1,2
	AddTriangle surface,0,2,3
	FreeBrush brush

	;back face
	brush = LoadBrush("res/sky/back.jpg",49)
	surface = CreateSurface(mesh,brush)
	AddVertex surface,+1,+1,+1,0,0
	AddVertex surface,-1,+1,+1,1,0
	AddVertex surface,-1,-1,+1,1,1
	AddVertex surface,+1,-1,+1,0,1
	AddTriangle surface,0,1,2
	AddTriangle surface,0,2,3
	FreeBrush brush

	;left face
	brush = LoadBrush("res/sky/right.jpg",49)
	surface = CreateSurface(mesh,brush)
	AddVertex surface,-1,+1,+1,0,0
	AddVertex surface,-1,+1,-1,1,0
	AddVertex surface,-1,-1,-1,1,1
	AddVertex surface,-1,-1,+1,0,1
	AddTriangle surface,0,1,2
	AddTriangle surface,0,2,3
	FreeBrush brush

	;top face
	brush = LoadBrush("res/sky/up.jpg",49)
	surface = CreateSurface(mesh,brush)
	AddVertex surface,-1,+1,+1,0,1
	AddVertex surface,+1,+1,+1,0,0
	AddVertex surface,+1,+1,-1,1,0
	AddVertex surface,-1,+1,-1,1,1
	AddTriangle surface,0,1,2
	AddTriangle surface,0,2,3
	FreeBrush brush

	ScaleMesh mesh,5000,2500,5000
	MoveEntity mesh,0,1500,0
	FlipMesh mesh
	EntityFX mesh,9

	Return mesh
End Function




;::::::::::::::::::::::::::
;        Sys_Loading
;::::::::::::::::::::::::::

Function Sys_Loading(percent)	
	ClsColor 130,180,250
	Cls
	Color 10,25,100
	Text 10,10,"[ LOADING... ]"
	Color percent*1.8,percent*2,255
	For i=10 To percent+10
		Line i,24,i,30
	Next
	Flip
End Function




;:::::::::::::::::::::::::::::
;     Mangement of the chat
;:::::::::::::::::::::::::::::

;Drawing
Function Chat_display()
	Local taille% = FontHeight() * 2 + 10
	
	Color 200,200,250
	Rect 10,screen_height-30,screen_width-20,25

	Color 20,20,50
	Text 15,screen_height-25,">> " + chat$
End Function




;::::::::::::::::::::::::::::
;  Mangement of the console
;::::::::::::::::::::::::::::

;Console of drawing
Type PostType
	Field author$
	Field date$
	Field msg$
End Type

; New messsage on the network console
Function Scr_NewPost(author$,date$,msg$)
	p.PostType = New PostType
	p\author = author
	p\date = date
	p\msg = msg
End Function

; Delete all posts
Function Scr_FlushPosts()
	For p.PostType = Each PostType
		Delete p.PostType
	Next
End Function

;Drawing
Function Scr_Consoledisplay()
	Local taille% = FontHeight() * 2 + 10
	;posts
	cnt = 0
	For p.PostType = Each PostType
		cnt = cnt + 1
		Color 80,130,180
		Rect 10,80+taille%*cnt,screen_width * 0.5,13
		
		Color 200,200,250
		Text 20,80+taille%*cnt,"From : " + p\author + ", " + p\date
		
		Color 60,60,100
		Text 10,98+taille%*cnt,p\msg
	Next
	
	If messageInfo <> "" Then
		Color 255, 0, 0 
		Text screen_halfwidth, screen_halfheight, messageInfo$, True
	EndIf
End Function