Strict

'Constants config :::::::::::::::::::::::::::::::::::::::::::::::::::
Global screen_width% = 800
Global screen_height% = 600
Global screen_depth% = 0
Global screen_halfwidth% = screen_width/2
Global screen_halfheight% = screen_height/2
Global pseudo$=""
Global ban:Timage
Global background:Timage

Global chrono_update% 
Global chat$

Const SET_VALUE% = 1
Const GET_VALUE% = 2

' Console of drawing
Type PostType
	Field author$
	Field date$
	Field msg$
End Type
Global Post:TList=CreateList()


SeedRnd MilliSecs()

'BKDB Init :::::::::::::::::::::::::::::::::::::::::::::::::::::::

'Including BKDB
Include "../../BlitzMax/Etna_inc.bmx" 

' Creation of the window
Graphics(screen_width,screen_height,screen_depth)
AppTitle="ETNA Chat Demo - by Progi1984"
HideMouse()


ETNA_Initialise()

ETNA_SetServer("http://repeatuntil.online.fr/Etna")

' Loading images
SetMaskColor(255,0,255)
ban = LoadImage("res/ban.jpg")
background = LoadImage("res/background.png")

' Setting the name of the user
pseudo$=InputText("Your name ? ", screen_width*0.4, screen_halfheight)

If pseudo$="" Then
	pseudo$="Anonyme"+Rand(0,100)
EndIf


Global messageInfo$ = ""

Local xScroll% = 0
Local angle% = 0
While Not KeyHit(KEY_ESCAPE)
	Cls
	DrawImage background,xScroll,0
	DrawImage background,xScroll - background.width,0
	DrawImage ban,0,0
	xScroll :+ 1
	If xScroll > screen_width Then xScroll = 0

	SetColor 20, 20, 20
	DrawOval(screen_width * 0.8 - 50, screen_height * 0.85 - 50, 100, 100)
	SetColor 200, 0, 0
	DrawLine(screen_width * 0.8, screen_height * 0.85, screen_width * 0.8 + (Cos(angle) * 40), screen_height * 0.85 + (Sin(angle) * 40))
	angle :+ 1
	If angle > 360 Then angle = 0

	
	ETNA_Update()
	' Interception of the result of the request
	If ETNA_Receive(GET_VALUE) Then
		If ETNA_GetState() = ETNA_OK Then
			'Reception of the chat
		  messageInfo = ""
					
			'Effacement des posts actuels
			Scr_FlushPosts()
				
			Local rec_author$ = ""
			Local rec_date$ = ""
			Local rec_msg$ = ""
			Local inc%
		
			' Parsing of the answer and building of new messages
			For inc% = 1 To ETNA_GetNbOfLines() Step 3
				rec_author$=ETNA_GetResult(inc)							
				rec_date$=ETNA_GetResult(inc + 1)
				rec_msg$=ETNA_GetResult(inc + 2)	
				Scr_NewPost(rec_author$, rec_date$, rec_msg$)	
			Next
		Else
			messageInfo = "Unable to update the Chat! Error = " + ETNA_GetState()				
		EndIf			
	EndIf
	
	If ETNA_Receive(SET_VALUE) Then
		' Answer of the server after the sending
		If ETNA_GetState() <> ETNA_OK Then messageInfo$ = "Unable to send the chat text! Error = " + ETNA_GetState() Else messageInfo$ = ""
	EndIf


	' Obtaining new messages
	chrono_update% = chrono_update% - 1
	If chrono_update% <= 0 Then
		messageInfo$ = "Updating the chat..."
		ETNA_Send(GET_VALUE,"ETNA_Chat.php?option=getchat")
		chrono_update% = 500
	EndIf
	

	SetColor 200,200,250
	DrawRect 10,screen_height-30,screen_width-20,25
	SetColor 20,20,50
  chat$ = dynamicInput(">> ", 15,screen_height-25)

	' Sending a message
	If Trim(chat$)<>"" Then
		ETNA_Send(SET_VALUE,"ETNA_Chat.php?option=setchat&msg=" + chat$ + "&author=" + pseudo$)
		chat$ = ""
		chrono_update% = 0
	EndIf
	
	' Drawing the chat in a console
	Scr_Consoledisplay()
	
	'F10 for a screenshot
	If KeyHit(KEY_F10)=1 Then 
		Screenshot()
	End If	
			
	Flip
Wend
End


'::::::::::::::::::::::::::::::
'  Mangement of the console
';:::::::::::::::::::::::::::::

' New message on the netowrk console
Function Scr_NewPost(author$,date$,msg$)
	Local p:posttype
	p = New PostType
	p.author = author
	p.date = date
	p.msg = msg
	ListAddFirst post,p
End Function

' Delete all posts
Function Scr_FlushPosts()
	Local p:posttype
	For p = EachIn Post
		ListRemove Post,p
	Next
End Function

' Drawing
Function Scr_Consoledisplay()
	Local size% = 36
	Local cnt#
	Local p:posttype
	
	'posts
	cnt = 0
	For p = EachIn Post
		cnt = cnt + 1
		SetColor 80,130,180
		DrawRect 10,80+size%*cnt,screen_width-20,13
		
		SetColor 200,200,250
		DrawText "From : " + p.author + ", " + p.date,20,80+size%*cnt
		
		SetColor 60,60,100
		DrawText p.msg,10,98+size%*cnt
	Next
	
	If messageInfo <> "" Then
		SetColor 255, 0, 0 
		DrawText messageInfo$, screen_width*0.4, screen_halfheight
	EndIf
	
	SetColor 255,255,255
End Function


'::::::::::::::::::::::::::::::::
'  Management of the screenshot
'::::::::::::::::::::::::::::::::

Function Screenshot()

	Local filename:String, padded:String
	Local num:Int = 0

	padded = num
	While padded.length < 3 
		padded = "0"+padded
	Wend
	filename = "screen"+padded+".png"
	
	While FileType(filename) <> 0
		num:+1

		padded = num
		While padded.length < 3 
			padded = "0"+padded
		Wend
		filename = "screen"+padded+".png"
	Wend

	Local img:tpixmap = GrabPixmap(0,0,GraphicsWidth(),GraphicsHeight())

	SavePixmapPNG(img, filename )
	
	Print "Screenshot saved as "+filename

EndFunction





'The code below can be found in the code archives as public source! 

Rem 
bbdoc: InputText works just as a normal input but in graphicsmode. It waits for you to press enter then returns a string.
EndRem 
Function InputText$(Text$,X,Y,password:Byte=False)
	FlushKeys
	Local Inp$
	Repeat
		Inp = TInput.Text(Text$,X,Y,password)
		Flip;Cls
	Until Inp <> ""

	Return Trim(Inp)
EndFunction


Rem 
bbdoc: InputText works just as a normal Textinput but it does NOT stop the program! Returns "" until ENTER is pressed then the message you have written is returned as a string.
endrem 
Function DynamicInput$(Text$,X,Y,password:Byte=False)
	Return TInput.Text(Text$,X,Y,password)
EndFunction


Type TInput
	Global tempText$

	Function Text$(Text$,X,Y,password:Byte=False)
		Local aKeytoGet = GetChar()
		If aKeytoGet'Anykey was pressed
			
			If aKeytoGet = 13 'ENTER
				Text$ = tempText$
				If Text$ = "" Then Text = " "
				tempText$ = ""
				FlushKeys
				Return Text$
			Else If aKeytoGet = 8 Or aKeytoGet = 4 'AscII For Backspace And Delete
				If Len( tempText$ ) > 0 Then tempText$ = Left$( tempText$, Len(tempText$) -1 )	
			Else' If aKeytoGet>=32 And aKeytoGet<=122 And Len(Message)<52
				tempText$:+ Chr$(aKeytoGet)
			EndIf
	
		EndIf
		
		If password = False Then	
			DrawText Text$ + tempText,X,Y
		Else
			Local t$ = ""
			For Local i = 1 To Len(tempText)
				t$ = t$ + "*"
			Next
			DrawText Text$ + t$,X,Y
		EndIf
		Return ""
	EndFunction
EndType

