unit app;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ETNA_inc, jpeg, ExtCtrls;

type
  Tfrm_Main = class(TForm)
    Button1: TButton;
    lbl_State: TLabel;
    btn_GetScore: TButton;
    lbl_nbinqueue: TLabel;
    GroupBox1: TGroupBox;
    log: TListBox;
    stb_infos: TStatusBar;
    ckb_threads: TCheckBox;
    img_Logo: TImage;
    lbl_Score: TLabel;
    Bevel1: TBevel;
    btn_SetScore: TButton;
    edt_Score1: TEdit;
    edt_score2: TEdit;
    Label1: TLabel;
    ckb_encrypted: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure btn_GetScoreClick(Sender: TObject);
    procedure Send(threaded, encrypted: boolean);
    Procedure SetState(state: string);
    procedure FormCreate(Sender: TObject);
    procedure btn_SetScoreClick(Sender: TObject);
  private
    { Private decls }
  public
    { Public decls }
  end;

var
  frm_Main: Tfrm_Main;
  pgrValue: byte;

Const

GET_SCORE = 1;
SET_SCORE = 2;

implementation

{$R *.dfm}

procedure Tfrm_Main.Button1Click(Sender: TObject);
begin
        // Informations
        lbl_State.Caption := 'ETNA State : ' + IntToStr(ETNA_GetState());
        lbl_nbinqueue.Caption := 'Number of commands in queue : ' + IntToStr(ETNA_GetNumberOfCommandsInQueue());
end;

procedure Tfrm_Main.btn_GetScoreClick(Sender: TObject);
begin
        log.Clear;
        Send(ckb_threads.Checked, ckb_encrypted.checked);
end;

Procedure Tfrm_Main.Send(threaded, encrypted: boolean);
var
        i: integer;
        score: Array [1..4] of ^Char;
begin
        If encrypted Then ETNA_SetKey('mySecretKey');

        Case threaded of
                // non-threaded request 
                False : begin
                        SetState('Idle');

                        If encrypted Then
                                ETNA_Send(ETNA_NO_THREAD, 'score_encrypted.php?opt=getScore', True)
                        Else
                                ETNA_Send(ETNA_NO_THREAD, 'score.php?opt=getScore', False);
                                
                        For i := 0 To ETNA_GetNbOfLines() do
                               log.Items.Add(ETNA_GetResult(i));

                        SetState('OK');
                end;
                // threaded request
                True : begin
                
                        SetState('Idle');

                        If encrypted Then
                                ETNA_Send(GET_SCORE, 'score_encrypted.php?opt=getScore', True , True)
                        Else
                                ETNA_Send(GET_SCORE, 'score.php?opt=getScore', False , True);

                        While Not ETNA_Receive(GET_SCORE) do
                                { Type events to refresh here : threads advantage }
                                ETNA_Update();

                        For i := 0 To ETNA_GetNbOfLines() do
                                log.Items.Add(ETNA_GetResult(i));

                        SetState('OK');
                end;
        end;
        lbl_Score.Caption :=  ETNA_GetResult(1) + ' - ' + ETNA_GetResult(2);

        For i := 1 To 4 do begin
                score[i] := nil;
        end;
        i := 0;

end;

procedure Tfrm_Main.FormCreate(Sender: TObject);
begin
        // Setting server
        ETNA_Setserver('http://repeatuntil.free.fr/Etna');
        SetState('OK');
end;

Procedure Tfrm_Main.SetState(state: string);
begin
        stb_infos.Panels.Items[0].Text := 'Application status : ' + state;
        stb_infos.Repaint;
end;

procedure Tfrm_Main.btn_SetScoreClick(Sender: TObject);
begin
        SetState('Idle');
        ETNA_Send(ETNA_NO_THREAD, 'score.php?opt=setScore&score1=' + edt_score1.Text + '&score2=' + edt_score2.Text);
        SetState('OK');
        { You can also use threads here if you want... }
end;

end.
