<?php

//////////////////////////////////////////////////////////////////////////
////       ETNA functions needed for the encryption/decryption        ////
////     Use them in your php if you are using with encryption        ////
//// Just do: "include 'ETNA_encryption.php';" at the top of your php ////
//////////////////////////////////////////////////////////////////////////
function ETNA_GetArg($key) 
{
	$ETNA_argEncrypted = array_key_exists("ETNA_argEncrypted",$_GET) ? $_GET["ETNA_argEncrypted"] : "";
	$ETNA_arg = ETNA_Decrypt($ETNA_argEncrypted, $key);
	parse_str($ETNA_arg, $ETNA_arrayArg);
	return $ETNA_arrayArg;
}


// RC4 function to encrypt or decrypt		
function ETNA_Rc4($inp, $key)
{
	for($i = 0; $i <= 255; $i++)
	{
		$S[$i]=$i;
	}
	
	$j=0;
	for($i = 0; $i <= 255; $i++)
	{
		if($j >= strlen($key))
		{
			$j=0;
		}
		$K[$i]=ord(substr($key,$j,1));
		$j=$j+1;
	}
	
	$j=0;
	for($i = 0; $i <= 255; $i++)
	{
		$j=($j + $S[$i]+$K[$i]) & 255;
		$temp = $S[$i];
		$S[$i] = $S[$j];
		$S[$j] = $temp;
	}
	
	$i=0;
	$j=0;
	$len=strlen($inp);
	for($x = 0; $x < $len; $x++)
	{
		$i=($i+1) & 255;
		$j=($j+$S[$i]) & 255;
		$temp = $S[$i];
		$S[$i] = $S[$j];
		$S[$j] = $temp;
		$t = ($S[$i] + ($S[$j] & 255)) & 255;
		$Y = $S[$t];
		$outp=$outp.chr(ord(substr($inp,$x,1))^$Y);
	}
	return $outp;
}


// Function to encrypt a string with a key
function ETNA_Encrypt($inp, $key)
{
  // Add 4 F to specify to ETNA that this php returns an encrypted string (and also convert to hexadecimal)
	return "FFFF".bin2hex(ETNA_Rc4($inp, $key));
}


// Function to decrypt a string with the key
function ETNA_Decrypt($inp, $key)
{
    // Convert it from hexadecimal to string
	$inp = @pack('H*', $inp);
	return ETNA_Rc4($inp, $key);
}
?>