; Basic example for the use of Etna
; Requests here uses thread
; To fully understand the code, please refer as well at the script score.php


Include "../../BlitzBasic/Etna_inc.bb" 

Graphics 800, 600, 0, 2 
SeedRnd MilliSecs()

ETNA_Initialise()

; There is an example of simple PHP file on the following server
ETNA_SetServer("http://repeatuntil.online.fr/Etna")
ETNA_SetKey("mySecretKey") ; Set the key for the encryption

; Define some user-defined constants
Const SET_SCORE% = 1
Const GET_SCORE% = 2

Print "Very simple example showing how to set and get an online score WITH ENCRYPTION."
Print "This example uses thread, which means the program is not slow down"
Print "by this database access."
Print

Print "Getting the previous score..."
ETNA_Send(GET_SCORE, "score_encrypted.php?opt=getScore", True) ; Set the third parameter to True to have encryption


Print "Generating random score and setting new score..."
score1 = Rand(10)
score2 = Rand(10)
ETNA_Send(SET_SCORE, "score_encrypted.php?opt=setScore&score1=" + score1 + "&score2=" + score2, True)

Print 
Print "Looping forever and waiting for requests to be received..."
Print
While ETNA_GetNumberOfCommandsInQueue() <> 0
  ; Update ETNA
  ETNA_Update()

  If ETNA_Receive(GET_SCORE) Then
    If ETNA_GetState() = ETNA_OK Then
      Print "Result for the request getting the score:"
      Print "Result = " + ETNA_GetResult()
      For i% = 1 To ETNA_GetNbOfLines()
        Print "Result line by line = " + ETNA_GetResult(i)
      Next
    Else
      Print "The request failed with the error message = " + ETNA_GetState()
    EndIf
    Print
  EndIf

  ; Check If we received some results
  If ETNA_Receive(SET_SCORE) Then
    If ETNA_GetState() = ETNA_OK Then
      Print "Result for the request setting the score:"
      Print "Result = " + ETNA_GetResult()
      For i% = 1 To ETNA_GetNbOfLines()
        Print "Result line by line = " + ETNA_GetResult(i)
      Next
    Else
      Print "The request failed with the error message = " + ETNA_GetState()
    EndIf
    Print
  EndIf
	
  Delay 1
Wend

Print
Print "Done. Press a key..."
WaitKey