// example using ETNA library with C++
// / ! \ this code uses ETNA thread !
#include <math.h>
#include <windows.h>
#include <string.h>
#include <stdio.h>
#include <stdio.h>
#include <tchar.h>
#include <stdlib.h>
#include <mbstring.h>
#include "..\..\C++\Etna.h"

// Define some user-defined constants
#define SET_SCORE 1
#define GET_SCORE 2

int main(void)
{
	InterfaceETNA ETNALib;
	int Score1,Score2;
	char CmdToSend[100], str[256];


	if(ETNALib.Initialise() == false)
	{
		printf("error ! \nPress enter key to quit ...");
		gets(str);
	}
	  // connexion au serveur
	ETNALib.SetServer("http://repeatuntil.online.fr/Etna");
	ETNALib.SetKey("mySecretKey");// Set the key for the encryption

	printf( "Very simple example showing how to set and get an online score WITH ENCRYPTION.");
	printf( "This example uses thread, which means the program is not slow down");
	printf( "by this database access.\n\n");

	printf( "Getting the previous score...\n");
	// Set the third parameter to True to have encryption
	ETNALib.Send(GET_SCORE, "score_encrypted.php?opt=getScore", true) ;


	printf( "Generating random score and setting new score...\n");
	Score1 = (int)floor(((rand() * 1.0f) / RAND_MAX) *10.0f);
	Score2 = (int)floor(((rand() * 1.0f) / RAND_MAX) *10.0f);
	sprintf(CmdToSend, "score_encrypted.php?opt=setScore&score1=%i&score2=%i", Score1, Score2);
	ETNALib.Send(SET_SCORE, &CmdToSend[0], true);

	printf( "\nLooping forever and waiting for requests to be received...\n\n");
	while (ETNALib.GetNumberOfCommandsInQueue() != 0)
	{
		// Update ETNA
		ETNALib.Update();

		if (ETNALib.Receive(GET_SCORE))
		{
			if (ETNALib.GetState() == ETNA_OK)
			{
				printf( "Result for the request getting the score:\n");
				printf( "Result = %s\n", ETNALib.GetResult());
				for (int i = 1; i<=ETNALib.GetNbOfLines(); i++)
					printf( "Result line by line = %s\n", ETNALib.GetResult(i));
			}else
				printf( "The request failed with the error message = %i\n", ETNALib.GetState());
		printf("\n");
		}

		// Check If we received some results
		if (ETNALib.Receive(SET_SCORE))
		{
			if (ETNALib.GetState() == ETNA_OK)
			{
				printf( "Result for the request setting the score:\n");
				printf( "Result = %s\n", ETNALib.GetResult());
				for(int i = 1; i<= ETNALib.GetNbOfLines(); i++)
					printf( "Result line by line = %s\n", ETNALib.GetResult(i));
			}else
				printf( "The request failed with the error message = %i\n", ETNALib.GetState());
			printf("\n");
		}
	
		Sleep(100);// Sleep some time so the program doesn't use a lot of performances
	}
	printf( "\nDone. Press enter key...\n");
	gets(str);
	return 0;
}