program score_encrypted_thread;

{$APPTYPE CONSOLE}

uses
  SysUtils, ETNA_inc in '../../Delphi/Etna_inc.pas';

Const
  SET_SCORE = 1;
  GET_SCORE = 2;

var
  score1: byte;
  score2: byte;
  i: integer;

begin
  { TODO -oUser -cConsole Main : placez le code ici }

  // Setting up the server
  ETNA_SetServer('http://repeatuntil.online.fr/Etna');
  // Setting up the key
  ETNA_SetKey('mySecretKey');

  writeln('Very simple example showing how to set and get an online score.');
  writeln('This example uses thread, which means the program is not slow down');
  writeln('by this database access.');
  writeln('');

  // Getting the score
  writeln('Getting the previous score...');
  ETNA_Send(GET_SCORE, 'score_encrypted.php?opt=getScore', True); //Set the third parameter to True to have encryption

  writeln('Generating random score and setting new score...');
  Randomize;
  score1 := Random(10);
  score2 := Random(10);
  writeln(inttostr(score1) + ' to ' + inttostr(score2));
  ETNA_Send(SET_SCORE, 'score_encrypted.php?opt=setScore&score1=' + intToStr(score1) + '&score2=' + intToStr(score2), True);

  writeln('');
  writeln('Looping forever and waiting for requests to be received...');
  writeln('');

  While (ETNA_GetNumberOfCommandsInQueue() <> 0) Do begin
        // Update ETNA
        ETNA_Update;

        If ETNA_Receive(GET_SCORE) Then begin
            If ETNA_GetState() = ETNA_OK Then begin
            writeln('Result for the request getting the score:');
            writeln('Result = ' + ETNA_GetResult());
            For i := 1 To ETNA_GetNbOfLines() Do writeln('Result line by line = ' + ETNA_GetResult(i));
          end
          else begin
            writeln('The request failed with the error message = ' + intToStr(ETNA_GetState()));
          end;
          writeln;
        end;
        
        // Check If we received some results
        If ETNA_Receive(SET_SCORE) Then begin
            If ETNA_GetState() = ETNA_OK Then begin
            writeln('Result for the request setting the score:');
            writeln('Result = ' + ETNA_GetResult());
            For i := 1 To ETNA_GetNbOfLines() Do writeln('Result line by line = ' + ETNA_GetResult(i));
          end
          else begin
            writeln('The request failed with the error message = ' + intToStr(ETNA_GetState()));
          end;
          writeln;
        end;

  end;

  readln;

end.

