; Basic example for the use of Etna
; Requests here uses thread
; To fully understand the code, please refer as well at the script score.php

OpenConsole()

ETNA_Initialise()

; There is an example of simple PHP file on the following server
ETNA_SetServer("http://repeatuntil.online.fr/Etna")

; Define some user-defined constants
#SET_SCORE = 1
#GET_SCORE = 2

PrintN("Very simple example showing how to set and get an online score.")
PrintN("This example uses thread, which means the program is not slow down")
PrintN("by this database access.")
PrintN("")

PrintN("Getting the previous score...")
ETNA_Send(#GET_SCORE, "score.php?opt=getScore", #False, #False)

PrintN("Generating random score and setting new score...")
score1 = Random(10)
score2 = Random(10)
ETNA_Send(#SET_SCORE, "score.php?opt=setScore&score1=" + Str(score1) + "&score2=" + Str(score2), #False, #False)

PrintN("")
PrintN("Looping forever and waiting for requests to be received...")
PrintN("")
While ETNA_GetNumberOfCommandsInQueue() <> 0
  ; Update ETNA
  ETNA_Update()

  If ETNA_Receive(#GET_SCORE) = #True
    If ETNA_GetState() = #ETNA_OK
      PrintN ("Result for the request getting the score:")
      PrintN("Result = " + ETNA_GetResult(-1))
      For i = 1 To ETNA_GetNbOfLines()
        PrintN("Result line by line = " + ETNA_GetResult(i))
      Next
    Else
      PrintN("The request failed with the error message = " + Str(ETNA_GetState()))
    EndIf
    PrintN("")
  EndIf

  ; Check If we received some results
  If ETNA_Receive(#SET_SCORE) = #True
    If ETNA_GetState() = #ETNA_OK
      PrintN("Result for the request setting the score:")
      PrintN("Result = " + ETNA_GetResult(-1))
      For i = 1 To ETNA_GetNbOfLines()
        PrintN("Result line by line = " + ETNA_GetResult(i))
      Next
    Else
      PrintN("The request failed with the error message = " + Str(ETNA_GetState()))
    EndIf
    PrintN("")
  EndIf

  Delay(1)
Wend

PrintN("")
PrintN("Done. Press a key...")
Input()
; IDE Options = PureBasic v4.00 (Windows - x86)
; CursorPosition = 9
; Folding = --