Framework BRL.D3D7Max2D
Import BRL.Retro
Import Pub.Win32

Strict

Include "../BlitzMax/Etna_inc.bmx" 
Include "gnet_inc.bmx"

Graphics 800, 600, 0

Local myGame$
Local myIp$

myGame = InputText("Please enter the game name: ", 0, 0)

ETNA_Initialise()
ETNA_SetServer("http://www.blitzmax.com/gnet")
GNET_SetPhp("gnet.php")

GNET_PingSite()
Local resultOK = GNET_AddServer(myGame)
If Not resultOK NotifyAndEnd("Failed to add server")

GNET_ListServers()

Local angle = 0  ' Some graphics effect to show that ETNA does not slow down the program
Repeat
  ETNA_Update()

	If KeyHit(KEY_SPACE) Then
		GNET_RefreshServer(myGame, "New server name!")
		GNET_ListServers()
	EndIf

	If KeyHit(KEY_ENTER) Then
		GNET_ListServers()
	EndIf

	' Just to try without thread to see the difference
	If KeyHit(KEY_LALT) Or KeyHit(KEY_RALT) Then
		ETNA_Send(ETNA_NO_THREAD, GNET_php + "?opt=ref&game=" + myGame)
	EndIf

  If KeyHit(KEY_ESCAPE) Then 
		GNET_RemoveServer(myGame)
		End
	EndIf


	If ETNA_Receive(GNET_PING) Then
		If ETNA_GetState() <> ETNA_OK Then NotifyAndEnd("Failed to ping")
		myIp$ = ETNA_GetResult()
	EndIf

	If ETNA_Receive(GNET_LIST_SERVER) Then
		If ETNA_GetState() <> ETNA_OK Then NotifyAndEnd("Failed to list servers")
		GNET_ReceiveList()
	EndIf
	
	If ETNA_Receive(GNET_REFRESH_SERVER) Then
		If ETNA_GetState() <> ETNA_OK Or ETNA_GetResult() <> "OK" Then NotifyAndEnd("Failed to refresh server")
	EndIf
	
	SetColor 255, 0, 0
	DrawText("Check on www.blitzbasic.com/gnet/gnet_servers.php", 0, 0)
	SetColor 255, 255, 255
	DrawText("Press space to refresh the server", 0, 20)
	DrawText("(Press alt to refresh the server without thread, and notice the slow down)", 0, 35)
	DrawText("Press enter to list the servers", 0, 50)
	DrawText("Press Esc to remove the server and exit", 0, 65)
	DrawText("Result of the ping: " + myIP, 0, 85)
	DrawText("Notice that the program is not slowed down by the repeated gnet access!", 100, 560)

	DrawText(LSet$("Game", 16) + LSet$("Server", 32) + LSet$("IP", 16), 0, 120)
	DrawText("-----------------------------------------------------------------------------", 0, 135)
	Local i% = 0
	For Local t:GNET_Server = EachIn GNET_ServerList
		DrawText(LSet$(t.game$, 16) + LSet$(t.server$, 32) + LSet$(t.ip$, 16), 0, 150 + i)
		i :+ 15
	Next

	SetColor 20, 20, 20
	DrawOval(350, 450, 100, 100)
	SetColor 200, 0, 0
	DrawLine(400, 500, 400 + (Cos(angle) * 40), 500 + (Sin(angle) * 40))
	angle :+ 1
	If angle > 360 Then angle = 0
			
	Flip
	Cls
Forever


Function NotifyAndEnd(text$)
	Notify text$, True
	End
End Function

'The code below can be found in the code archives as public source! 

Rem 
bbdoc: InputText works just as a normal input but in graphicsmode. It waits for you to press enter then returns a string.
EndRem 
Function InputText$(Text$,X,Y)
	Local Inp$
	Repeat
		Inp = TInput.Text(Text$,X,Y)
		Flip;Cls
	Until Inp <> ""

	Return Trim(Inp)
EndFunction


Rem 
bbdoc: InputText works just as a normal Textinput but it does NOT stop the program! Returns "" until ENTER is pressed then the message you have written is returned as a string.
endrem 
Function DynamicInput$(Text$,X,Y)
	Return TInput.Text(Text$,X,Y)
EndFunction


Type TInput
	Global tempText$

	Function Text$(Text$,X,Y)
		Local aKeytoGet = GetChar()
		If aKeytoGet'Anykey was pressed
			
			If aKeytoGet = 13 'ENTER
				Text$ = tempText$
				If Text$ = "" Then Text = " "
				tempText$ = ""
				FlushKeys
				Return Text$
			Else If aKeytoGet = 8 Or aKeytoGet = 4 'AscII For Backspace And Delete
				If Len( tempText$ ) > 0 Then tempText$ = Left$( tempText$, Len(tempText$) -1 )	
			Else' If aKeytoGet>=32 And aKeytoGet<=122 And Len(Message)<52
				tempText$:+ Chr$(aKeytoGet)
			EndIf
	
		EndIf
			
		DrawText Text$ + tempText,X,Y
		Return ""
	EndFunction
EndType
